﻿using System.Collections.Specialized;
using System.Web;
using System.Xml.Linq;
using DD4T.Mvc.Providers;

namespace Mvc4Demo.Sitemap
{
    public class DistributedSiteMapNode : TridionSiteMapNode
    {


        //public DistributedSiteMapNode(SiteMapProvider provider, string key, string uri, string url, string title, string description, IList roles, NameValueCollection attributes, NameValueCollection explicitResourceKeys, string implicitResourceKey, string subnavigationUrl) :
        //    base(provider, key, uri, url, title, description, roles, attributes, explicitResourceKeys, implicitResourceKey)
        //{
        //    this.SubnavigationUrl = subnavigationUrl;
        //}
        public DistributedSiteMapNode(SiteMapProvider provider, XElement element) :
            base (provider, element.Attribute("id").Value, GetUri(element), element.Attribute("url").Value, element.Attribute("title").Value,
            element.Attribute("description").Value, null, GetAllAttributes(element), null, null)
        {
            if (element.Attribute("subnavigation") != null)
                SubnavigationUrl = element.Attribute("subnavigation").Value;
        }

        private static string GetUri(XElement element)
        {
            return element.Attribute("uri") == null ? "tcm:0-0-0" : element.Attribute("uri").Value;
        }

        private static NameValueCollection GetAllAttributes(XElement element)
        {
            var attributes = new NameValueCollection();
            foreach (var a in element.Attributes())
            {
                attributes.Add(a.Name.ToString(), a.Value);
            }
            return attributes;
        }

        public string SubnavigationUrl { get; set; }
    }
}